package net.eidiot.app
{
	import flash.display.MovieClip;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.utils.getDefinitionByName;
	
	import net.eidiot.utils.TextUtil;
	/**
	 * A simple class for preload.
	 * 
	 * @author eidiot (http://eidiot.net)
	 */	
	public class Preloader extends MovieClip
	{
		//======================================================================
		//							Constructor
		//======================================================================
		public function Preloader()
		{
			stop();
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			createOutput();
			addListener();
		}
		//======================================================================
		//							Protected Method
		//======================================================================
		protected function getDocClass():Class
		{
			var url:String = loaderInfo.url;
			var className:String = url.slice(url.lastIndexOf("/") + 1, url.lastIndexOf(".swf"));
			try
			{
				return getDefinitionByName(className) as Class; 
			}
			catch (err:ReferenceError)
			{
				output("Invalid swf file name.");
			}
			return null;
		}
		//======================================================================
		//							Private Method
		//======================================================================
		private function createOutput():void
		{
			var tf:TextField = TextUtil.createOutput(stage.stageWidth, new TextFormat("Verdana"));
			addChild(tf);
			tf.y = (stage.stageHeight - tf.height) / 2;
			tf.autoSize = TextFieldAutoSize.CENTER;
		}
		private function output(str:String):void
		{
			TextField(getChildAt(0)).text = str;
		}
		private function addListener():void
		{
			loaderInfo.addEventListener(ProgressEvent.PROGRESS, onProgress);
			loaderInfo.addEventListener(Event.COMPLETE, onComplete);
		}
		private function removeListener():void
		{
			loaderInfo.removeEventListener(ProgressEvent.PROGRESS, onProgress);
			loaderInfo.removeEventListener(Event.COMPLETE, onComplete);
		}
		//======================================================================
		//							Event Handler
		//======================================================================
		private function onProgress(e:ProgressEvent):void
		{
			var percent:int = e.bytesLoaded / e.bytesTotal * 100;
			output("Loading ... " + percent + "%");
		}
		private function onComplete(e:Event):void
		{
			removeListener();
			nextFrame();
			var docClass:Class = getDocClass();
			if (docClass)
			{
				removeChildAt(0);
				addChild(new docClass);
			}
		}
	}
}